#version 430 core

uniform float fGlobalTime; // in seconds
uniform vec2 v2Resolution; // viewport resolution (in pixels)

uniform sampler1D texFFT; // towards 0.0 is bass / lower freq, towards 1.0 is higher / treble freq
uniform sampler1D texFFTSmoothed; // this one has longer falloff and less harsh transients
uniform sampler2D texBricks;
uniform sampler2D texGrunge;
uniform sampler2D texMono;
uniform sampler2D texNoise;
uniform sampler2D texNormal;
uniform sampler2D texPaper;
uniform sampler2D texPooBrain;

layout(location = 0) out vec4 out_color; // out_color must be written in order to see anything

vec3 rotx(vec3 p, float a)
{
  mat3 m = mat3(1., 0., 0.,
                0., cos(a), -sin(a),
                0., sin(a), cos(a));
  return m*p;
}

vec3 rotz(vec3 p, float a)
{
  mat3 m = mat3(cos(a), -sin(a), 0.,
                sin(a), cos(a), 0.,
                0., 0., 1.);
  return m*p;
}

float a(vec3 p)
{
  float t = texture(texFFT, .007).x*2.;
  vec3 q = mod(p, vec3(5.))-.5*vec3(5.);
   q =  rotz(rotx(q, fGlobalTime), fGlobalTime);
   return length(max(abs(q)-vec3(1.+t), vec3(0.)));
}

float b(vec3 p)
{
  return length(p)-5.;
}

vec3 gn(vec3 p)
{
vec2 e = vec2(.002, 0.);
  return normalize(vec3(b(p+e.xyy)-b(p-e.xyy),
                        b(p+e.yxy)-b(p-e.yxy),
                        b(p+e.yyx)-b(p-e.yyx)));
}

vec3 ga(vec3 p)
{
vec2 e = vec2(.02, 0.);
  return normalize(vec3(a(p+e.xyy)-a(p-e.xyy),
                        a(p+e.yxy)-a(p-e.yxy),
                        a(p+e.yyx)-a(p-e.yyx)));
}

void main(void)
{
  vec2 uv = (-1.+2.*gl_FragCoord.xy/v2Resolution)*vec2(v2Resolution.x/v2Resolution.y, 1.);
    vec3 co;

  vec3 rd = normalize(vec3(uv, 1.));
  vec3 o = vec3(5., 5., 5.);

  vec3 p = o;

  float dr = 0.;

  for(int i = 0; i < 64; ++i)
  {
    float d = a(p);
    p += d*rd;
    ++dr;
    if(d< .001)
      break;
  }

  vec3 n = ga(p);

  dr /= 63.;


    co = max(dot(n, normalize(o-p)), 0.)*vec3(1., .6, .7);
  co = mix(co, vec3(.7, .8, .9), min(distance(p, o)*.01, 1.));
    co += vec3(1., .9, .3)*dr;
  vec3 ref = reflect(rd, n);
  
   vec3 pref = p+ref*50.;

  for(int i = 0; i < 64; ++i)
  {
    float d = a(p);
    pref += d*ref;
    if(d< .001)
      break;
  }

    n = ga(pref);

  vec3 coref = max(dot(n, normalize(o-pref)), 0.)*vec3(.7, .6, 1.);
  coref = mix(co, vec3(.7, .8, .9), min(distance(pref, o)*.01, 1.));
  co = mix(co, coref, .5);

out_color = vec4(co, 1.);
}